# Next steps

Already [completed the tutorial](getting-started-tutorial-1.md)? Ready to build your own app or library, or just want to learn more? These resources will help you on your way.

* Check out some code examples:

    * The [Uno Gallery and Playground](https://github.com/unoplatform/uno.Playground) showcases many of the UI controls supported by Uno.

    * With [Uno Calculator](https://calculator.platform.uno/) we took Microsoft's open-sourced Windows 10 Calculator, ported it to C#, and put it on Android, iOS, and WebAssembly. [Check out all the code here.](https://github.com/unoplatform/calculator)

    * [Uno Azure DevOps (UADO)](https://github.com/unoplatform/uado) is our reference app, built from the ground up for Uno.

* The Uno Platform brings Microsoft's UWP framework to Android, iOS, and WebAssembly. The wealth of [official Microsoft documentation on the UWP framework](https://docs.microsoft.com/en-us/windows/uwp/develop/) is a great place to start, particularly if you've never used UWP or Xaml before.

* To find out more about cross-platform development with Uno, consult the rest of the docs here, including a list of [supported features](supported-features.md) and [general development tips](using-uno-ui.md).

* [Uno Platform Workshop](https://github.com/unoplatform/workshops) - In this workshop you will learn by creating a real-world mobile & web app using Uno Platform. The workshop covers: The philosophy behind Uno development, Tooling and component ecosystem, Creating rich and responsive UI, Interoperability with native code. And of course we will show how to contribute to the Uno Platform itself.

* If you have a question about Uno that others might benefit from, post it on [StackOverflow](https://stackoverflow.com/questions/ask?tags=uno-platform) using the 'uno-platform' tag. Remember to check if the question [already exists](https://stackoverflow.com/questions/tagged/uno-platform) and to follow StackOverflow's [question guidelines](https://stackoverflow.com/help/how-to-ask). You'll need to sign up to StackOverflow if you're not signed up already.

* If you think you've encountered a bug (e.g., something works on UWP but not on another platform), [check for an existing issue on GitHub](https://github.com/unoplatform/uno/issues) and create one if none exists. We don't like bugs, but we do like bug reports!

* If you're ready to contributing to Uno, great! Check out our guides on [building Uno](uno-development/debugging-uno-ui.md) and [creating UI samples](uno-development/working-with-the-samples-apps.md).

* To chat with the Uno Platform team and the Uno community, visit our [Gitter channel](https://gitter.im/uno-platform/Lobby).

* A knowledge of working with GitHub and Forks, Pull and Push requests is desireable. To learn more about Forks please see official GitHub documentation. [GitHub - Forks](https://help.github.com/en/github/collaborating-with-issues-and-pull-requests/working-with-forks).
